MODULE Zzzap; (* delete superfluous files from RAMdisk C.
                 Designed to be used in AUTO folder after RD and AUTODISK.
                 Based on a C program by John Purbrick, modifications and
                 translation to Modula-2 by Bill Silvert. *)

FROM InOut IMPORT Write, WriteString, WriteLn, Read;
FROM Strings IMPORT Concat;
FROM GEMDOS IMPORT SetDTA, SFirst, SNext, Delete, DirDelete;
FROM SYSTEM IMPORT ADR;
FROM ASCII IMPORT ESC;

TYPE DTA =  RECORD
              dummy : ARRAY [0..29] OF CHAR;
              name  : ARRAY [0..13] OF CHAR;
            END;
            
CONST DEBUG = FALSE;

VAR result : INTEGER;
    path : ARRAY [0..30] OF CHAR;
    DTAbuffer : DTA;
    
PROCEDURE Erase(VAR filename : ARRAY OF CHAR );
BEGIN
    WriteString(filename);
    IF NOT DEBUG
    THEN IF Delete(filename)
         THEN WriteString(" deleted.")
         ELSE WriteString(" NOT deleted."); Read(path[0]);
         END;
    END;
    WriteLn;
END Erase;

PROCEDURE Warn;
BEGIN
    WriteString("  Hit any key --"); Read(path[0])
END Warn;

BEGIN
    Write(ESC); Write('E'); WriteLn; (* clear screen *)
    WriteString("ZZZAP erases unneeded files from RAMdisk C"); WriteLn;
    WriteString("Original version in C by John Purbrick, adapted"); WriteLn;
    WriteString("for TDI/Modula-2 by Bill Silvert, 87/01/28, ver. 0.0");
    WriteLn; WriteLn; WriteString("Erasing Files:"); WriteLn; WriteLn;
    Erase("C:\DESKTOP.INF");
    SetDTA(ADR(DTAbuffer));
    path := "C:*.ACC";
    SFirst(path, 0, result);
    WHILE result > -1 DO
      Concat("C:\", DTAbuffer.name, path);
      Erase(path);
      SNext(result);
    END;
    path := "C:\AUTO\*.*";
    SFirst(path, 0, result);
    WHILE result > -1 DO
      Concat("C:\AUTO\", DTAbuffer.name, path);
      Erase(path);
      SNext(result);
    END;
    IF DEBUG
    THEN WriteString("AUTO remains.")
    ELSE IF DirDelete("C:\AUTO")
         THEN WriteString("Empty AUTO folder deleted.")
         ELSE WriteString("Unable to delete AUTO folder."); Warn;
         END
    END;
    WriteLn;
    IF DEBUG THEN Warn END;
END Zzzap.         
